<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_specialty".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderSpecialty".
 *
 * Columns in table "provider_specialty" available as properties of the model,
 * followed by relations of table "provider_specialty" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property integer $sub_specialty_id
 * @property integer $primary_specialty
 *
 * @property Provider $provider
 * @property SubSpecialty $subSpecialty
 */
abstract class BaseProviderSpecialty extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_specialty';
    }

    public static function representingColumn()
    {
        return 'id';
    }

    public function rules()
    {
        return array(
            array('provider_id, sub_specialty_id', 'required'),
            array('provider_id, sub_specialty_id, primary_specialty', 'numerical', 'integerOnly' => true),
            array('id, provider_id, sub_specialty_id, primary_specialty', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'subSpecialty' => array(self::BELONGS_TO, 'SubSpecialty', 'sub_specialty_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => Yii::t('app', 'Provider'),
            'sub_specialty_id' => Yii::t('app', 'Sub Specialty'),
            'specialty_id' => Yii::t('app', 'Specialty'),
            'primary_specialty' => Yii::t('app', 'Primary Specialty'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        //don't enable eager loading here
        // it won't filter by provider name if eager loading isn't enabled
        // these conditions allow to search by id or name (with eager loading)
        if (!intval($this->provider_id) && is_string($this->provider_id) && strlen($this->provider_id) > 0) {
            $criteria->with[] = 'provider';
            $criteria->addSearchCondition("provider.first_last", $this->provider_id);
        } else {
            $criteria->compare('t.provider_id', $this->provider_id);
        }

        //$criteria->compare('sub_specialty_id', $this->sub_specialty_id);
        if (!intval($this->sub_specialty_id) && is_string($this->sub_specialty_id)
                && strlen($this->sub_specialty_id) > 0) {
            $criteria->with[] = 'subSpecialty';
            $criteria->addSearchCondition("subSpecialty.name", $this->sub_specialty_id);
        } else {
            $criteria->compare('t.sub_specialty_id', $this->sub_specialty_id);
        }

        return new CActiveDataProvider(
            get_class($this),
            array(
                'criteria' => $criteria,
                'pagination' => array('pageSize' => 100)
            )
        );
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderSpecialty|ProviderSpecialties', $n);
    }

}
